<?php

if (! defined ( 'BASEPATH' ))
	exit ( 'No direct script access allowed' );

if ( ! defined('_SBG_REGISTER_FOR')) 					define('_SBG_REGISTER_FOR', 				'DK');
if ( ! defined('_SBG_REGISTER_VIP_FOR')) 				define('_SBG_REGISTER_VIP_FOR', 				'VIP');
if ( ! defined('_SBG_CHARGING_FOR')) 					define('_SBG_CHARGING_FOR', 				'NAP');
if ( ! defined('_SBG_SYNTAX_ERR')) 					define('_SBG_SYNTAX_ERR', 			'SYNTAX_ERR');

if ( ! defined('_SBG_CHARGING_SUCCESS')) 				define('_SBG_CHARGING_SUCCESS', 1);
if ( ! defined('_SBG_CHARGING_FAIL')) 					define('_SBG_CHARGING_FAIL', -1);
if ( ! defined('_SBG_CHARGING_FAIL_NOT_ENOUGH')) 		define('_SBG_CHARGING_FAIL_NOT_ENOUGH', 401);
if ( ! defined('_SBG_CHARGING_FAIL_NOT_VIETTEL')) 		define('_SBG_CHARGING_FAIL_NOT_VIETTEL', 402);
if ( ! defined('_SBG_CHARGING_NUMBER_NOT_EXISTED')) 	define('_SBG_CHARGING_NUMBER_NOT_EXISTED', 403);
if ( ! defined('_SBG_CHARGING_NUMBER_NOT_AVAILABLE')) 	define('_SBG_CHARGING_NUMBER_NOT_AVAILABLE', 404);
if ( ! defined('_SBG_CHARGING_NUMBER_CHANGED_OWNER')) 	define('_SBG_CHARGING_NUMBER_CHANGED_OWNER', 405);
if ( ! defined('_SBG_CHARGING_FAIL_MORETHAN_LIMIT')) 	define('_SBG_CHARGING_FAIL_MORETHAN_LIMIT', 406);
if ( ! defined('_SBG_CHARGING_GENERAL_ERROR')) 			define('_SBG_CHARGING_GENERAL_ERROR', 440);
if ( ! defined('_SBG_CHARGING_NUMBER_NOT_REGISTED')) 	define('_SBG_CHARGING_NUMBER_NOT_REGISTED', 501);
if ( ! defined('_SBG_CHARGING_MAX_VALUE')) 				define('_SBG_CHARGING_MAX_VALUE', 50000);

if ( ! defined('_SBG_PAIDTYPE_SMS')) define('_SBG_PAIDTYPE_SMS', 1);
if ( ! defined('_SBG_PAIDTYPE_CARD')) define('_SBG_PAIDTYPE_CARD', 2);

class Collaborator_model extends CI_Model {
	
	const TOKENPW = 'violet';
	const SRC = 'SBG';
	private $arrServicesPattern = array(
									_SBG_REGISTER_FOR => array('pattern' => '/^(DK)$/'),
									_SBG_REGISTER_VIP_FOR => array('pattern' => '/^(VIP)([[:blank:]])([a-zA-Z0-9]{1,})$/'),
									_SBG_CHARGING_FOR => array('pattern' => '/^(NAP)$/')
								);
	
	public function __construct() {
		parent::__construct ();
		$this->vservices->setApiUrl ( $this->config->item ( 'api_url' ) );
		$this->vservices->setConnection ( $this->curl );
		$this->load->helper('language');
		$this->lang->load('messages', 'message');
	}
	
	public function isExistUser($username){
		return false;
	}
	
	public function serviceAnalys($service){
		
		$aryMatched = array();	
		$aryContent = array();
		$result = FALSE;
		foreach ($this->arrServicesPattern as $case => $pattern)
		{
			$result = preg_match($pattern['pattern'], strtoupper(trim($service)));
			if ((bool)$result) {
				$aryMatched = explode(' ', trim($service));
				break;
			}
		}
		
		$case = (bool)$result ? $case:_SBG_SYNTAX_ERR;
		
		foreach($aryMatched as $k => $val) {
			if ($k > 0) $aryContent[] = $val;
		}
		
		return array('case' => $case, 'content' => $aryContent);
	}
	
	public function processUser($user, $sentNumber){
		$data = array();	
		$serviceAnalys = $this->serviceAnalys($user['service']);
		
		$case = $serviceAnalys['case'];
		$aryContents = isset($serviceAnalys['content']) ? $serviceAnalys['content']: null;
		
		switch($case){
			case _SBG_REGISTER_FOR:
				$data = $this->registerUser($user);
				break;
			case _SBG_REGISTER_VIP_FOR:
				$p_code = $aryContents[0];
				$data = $this->registerVipUser($user, $p_code);
				break;
			case _SBG_CHARGING_FOR:
				$data = $this->chargingForUser($user, $sentNumber);
				break;
			case _SBG_SYNTAX_ERR:
			default:
				$data['success'] = 0;
				$data['user'] = $user;
				$data['error'] = lang('_SBG_MO_SYNTAX_ERR_MSG');
				break;
		}
		
		return $data;
		
	}

	public function registerUser($user){

		$data = array();
		$data['user'] = $user;
		$this->load->model('frontend/user_model');
		$this->load->model('services/services_model');
		$src = self::SRC;
		$token = md5($user['username'] . self::TOKENPW);
		$sms = '';
		$collborator = $user['collboratorId'];
		$username = $user['username'];
		$password = $this->createRandomPassword();
		$fullname = $user['fullname'];
		$school = $user['school'];
		$province = $user['province'];
		$district = $user['district'];
		
		$strResult = $this->vservices->actionExecute ( 'update', array (
				'token' => $token,
				'src' => $src,
				'username' => $username,
				'fullname' => $fullname,
				'phone' => $username,
				'password' => $password,
				'school' => $school,
				'province' => $province
			), 'user' );
		
		$arrUser = array();
		$arrResult = array();
		parse_str($strResult, $arrResult);
		$status = (int)$arrResult['status'];

		switch ($status){
			case 0 :
				$this->load->model('frontend/servicepackage_model');
				$trialpackage=$this->servicepackage_model->getTrialPackage();
				$us_id = $arrResult['id'];
				$arrUser['us_id'] = $us_id;
				$arrUser['cellphone'] = $username;
				$arrUser['collborator'] = $collborator;
				$arrUser['acc_balanced'] = 0;
				$arrUser['p_id'] = $trialpackage['p_id'];
				$arrUser['expire_date'] = date('Y-m-d', strtotime("+" . $this->config->item("trial_period") . " days", time()));
				$arrUser['province'] = $province;
				$arrUser['district'] = $district;
				$arrUser['created_time'] = date ( 'Y-m-d H:i:s' );
				$arrUser ['updated_time'] = date ( 'Y-m-d H:i:s' );
				$this->db->insert ( 'tbluser', $arrUser );
				$aryPatterns = array ('/:trialdays:/', '/:username:/', '/:password:/');
				$trialdays = $this->config->item('trial_period');
				$trialdays = strlen($trialdays) < 2 ? '0'. $trialdays : $trialdays;
				if ($this->user_model->isViettel($username)){
					$sms = preg_replace($aryPatterns, array($trialdays. ' ngay', $username, $password), lang('_SBG_MO_USER_VIETTEL_REGISTER_SUCCESS_MSG'));
				}else{
					$aryPatterns = array ('/:username:/', '/:password:/');
					$sms = preg_replace($aryPatterns, array($username, $password), lang('_SBG_MO_USER_NOT_VIETTEL_REGISTER_SUCCESS_MSG'));
				}
				$sendMT = $this->services_model->sendMT($username, $sms);
				$data['success'] = 1;
				break;
			case 2:
			case 4:
				$sms = lang('_SBG_MO_USER_REGISTER_DUPLICATE_MSG');
				$sendMT = $this->services_model->sendMT($username, $sms);
				$aryPatterns = array('/:username:/');
				$error = preg_replace($aryPatterns, array($username), lang('_SBG_MO_COLLABOLATOR_REGISTER_DUPLICATE_MSG'));
				$data['success'] = 0;
				$data['error'] = $error;
				break;
			default:
				$data['success'] = 0;
				$data['error'] = $arrUser['errMsg'];
				break;
		}
	
		return $data;
	}
	
	public function registerVipUser($arrUser, $p_code){
		$data = array();
		$data['user'] = $arrUser;
		$this->load->model('frontend/user_model');
		$username = $arrUser['username'];
		$result = $this->user_model->get_user_by_cellphone ( $username );
		$package = $this->user_model->get_package ( ( int ) $p_code );
		if (!$package)
		{
			$data['success'] = 0;
			$data['error'] = lang('_SBG_MO_USER_REGISTER_VIP_NOT_FOUND_MSG');
			$data['user'] = $arrUser;
			return $data;
		}
		if ($result) {
			if ($result ['acc_balanced'] >= $package ['p_price']) {
				$us_id = $result ['us_id'];
				$user ['acc_balanced'] = $result ['acc_balanced'] - $package ['p_price'];
				if ($this->user_model->checkLicense ( $us_id )) {
					$user ['expire_date'] = date ( 'Y-m-d', strtotime ( $result ['expire_date'] . ' + ' . $package ['p_period'] . ' month' ) );
				} else {
					$user ['expire_date'] = date ( 'Y-m-d', strtotime ( 'now + ' . $package ['p_period'] . ' month' ) );
				}
				
				$user ['p_id'] = $package ['p_id'];
				$user ['updated_time'] = date ( 'Y-m-d H:i:s' );
				
				$this->user_model->updateUser ( $us_id, $user );
				$aryPatterns = array('/:period:/');
				$sms = preg_replace($aryPatterns, array(date ( 'd/m/Y', strtotime ( $user ['expire_date'] ) )), lang('_SBG_MO_USER_REGISTER_VIP_SUCCESS_MSG'));
				$sendMT = $this->services_model->sendMT($username, $sms);
		
				
				$data['success'] = 1;
				$this->user_model->insertRegisterVipLog($username, $package['p_id'], $true);
			} else {
				$sms = lang('_SBG_MO_USER_REGISTER_VIP_FAIL_NOT_ENOUGH_MSG');
				$sendMT = $this->services_model->sendMT($username, $sms);
				
				$data['success'] = 0;
				$data['error'] = $sms;
			}
		} else {
			$aryPatterns = array('/:username:/');
			$sms = preg_replace($aryPatterns, array($username), lang('_SBG_MO_ACCOUNT_NOT_FOUND_MSG'));
			$sendMT = $this->services_model->sendMT($username, $sms);
			
			$data['success'] = 0;
			$data['error'] = $sms;
		}
	
		return $data;
	}
	
	public function chargingForUser($user, $sentNumber){

		$this->load->model('services/services_model');
		$this->load->model('frontend/user_model');
		$data = array();
		$data['user'] = $user;
		$username = $user['username'];
		$amount = $user['amount'];
	
		$result =$this->services_model->chargeRootAccountProcess($sentNumber, $amount, $sentNumber.' paid for SBG');

		if ($result == _SBG_CHARGING_SUCCESS) {
			$smsReturn = $this->user_model->rechargeAccount($username, $amount);
			
			$arySmsReturn = explode ('|', $smsReturn);
			$aryPatterns = array('/:amount:/', '/:sentNumber:/');
			$smsMT = preg_replace($aryPatterns, array($amount, $sentNumber), lang('_SBG_MO_PAY_TO_ACCOUNT_FOR_MSG'));
			
			$sendMT = $this->services_model->sendMT($this->services_model->formatPhoneNumber($username, -1), $smsMT);
			$data['success'] = 1;
			
			//write to paid log
			$paidTime = date('Y-m-d H:i:s');
			$this->user_model->insertPaidlog($sentNumber, $username, _SBG_PAIDTYPE_SMS, $amount, $paidTime);
		}
		else if ($result == _SBG_CHARGING_FAIL_NOT_ENOUGH) {
			$aryPatterns = array ('/:sentNumber:/');
			$smsReturn = preg_replace($aryPatterns, array($sentNumber), lang('_SBG_MO_CHARGING_FAIL_NOT_ENOUGH_MSG'));	

			$data['success'] = 0;
			$data['error'] = $smsReturn;
		}
		else if ($result == _SBG_CHARGING_FAIL_MORETHAN_LIMIT) {
			$aryPatterns = array ('/:sendid:/');
			$smsReturn = preg_replace($aryPatterns, array($sentNumber), lang('_SBG_MO_CHARGING_FAIL_MORETHAN_LIMIT_MSG'));
			//$smsReturn = _SBG_MO_PROCCESS_ERR.'|'.$smsReturn;
			$data['success'] = 0;
			$data['error'] = $smsReturn;
		}else if ($result == _SBG_CHARGING_FAIL_NOT_VIETTEL || $result == _SBG_CHARGING_NUMBER_NOT_EXISTED || $result == _SBG_CHARGING_NUMBER_NOT_AVAILABLE) {
			$smsReturn = lang('_SBG_MO_CHARGING_FAIL_NOT_VIETTEL_MSG');
			$data['success'] = 0;
			$data['error'] = $smsReturn;
		}				
		else {
			$smsReturn = lang('_SBG_MO_CHARGING_FAIL_MSG');
			$data['success'] = 0;
			$data['error'] = $smsReturn;
		}
	
		return $data;
	}
	
	
	public function createRandomPassword(){
		$alphabet = "0123456789";
		$pass = array ();
		$alphaLength = strlen ( $alphabet ) - 1;
		for($i = 0; $i < 6; $i ++) {
			$n = rand ( 0, $alphaLength );
			$pass [] = $alphabet [$n];
		}
		return implode ( $pass );
	}
	
	public function getProvinceAndDistict($province, $district){
		$result['province'] = $province;
		$result['district'] = $district;
		$provinces = lang('_PROVINCES_');

		foreach ($provinces as $key => $pro):
			if($province == $pro){
				$result['province'] = $key;
				break;
			}
		endforeach;
		$sql = "SELECT * FROM tbldistrict where province_id = ? AND district_name = ?";
		
		$query = $this->db->query ( $sql, array ($result['province'], $result['district']) );
		if ($query->num_rows () > 0) {
			$row = $query->row_array ();
			$result['district'] = $row['district_id'];
		}
		return $result;
	}
	
	public function updateCollaborator($id, $collaborator){
		$this->db->where ( 'id', $id );
		return $this->db->update ( 'tblcollaborator', $collaborator );
	}
	
	public function checkPassCollaborator($id, $passwd){
		$passwd = md5($passwd);;
		$sql = "SELECT * FROM tblcollaborator WHERE id = ? AND passwd = ?";
		$this->db->query($sql, array('id'=>$id, 'passwd'=>$passwd));
		if ($this->db->affected_rows() >0){
			return true;
		}else{
			return false;
		}
	}
}